#include <stdio.h>
#include <stdlib.h>
#include "wm_gpio.h"
#include "wm_osal.h"


#define BLINK_TASK_SIZE 2048
static OS_STK BlinkTaskStk[BLINK_TASK_SIZE];
#define BLINK_TASK_PRIO 32

void blink_task(void *data)
{
	printf("Blink started\n");

	tls_gpio_cfg(WM_IO_PB_05, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_11, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_16, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_17, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_18, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_25, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);
	tls_gpio_cfg(WM_IO_PB_26, WM_GPIO_DIR_OUTPUT, WM_GPIO_ATTR_FLOATING);

	u8 led_state = 0;

	for (;;)
	{
		tls_gpio_write(WM_IO_PB_05, led_state);
		tls_gpio_write(WM_IO_PB_11, led_state);
		tls_gpio_write(WM_IO_PB_16, ~led_state);
		tls_gpio_write(WM_IO_PB_17, led_state);
		tls_gpio_write(WM_IO_PB_18, ~led_state);
		tls_gpio_write(WM_IO_PB_25, ~led_state);
		tls_gpio_write(WM_IO_PB_26, led_state);
		tls_os_time_delay(HZ / 1.5f);
		led_state = ~led_state;
	}
}

void UserMain(void)
{

	tls_os_task_create(NULL, NULL, blink_task, NULL, (void *)BlinkTaskStk, BLINK_TASK_SIZE * sizeof(u32), BLINK_TASK_PRIO, 0);

}